/*
 *		bin.out.h      12 Mar 86    edb
 *      definition of simple memory-image file format similar
 *      in spirit to a.out on UNIX systems
 *		Copyright 1986 Eric D. Black
 */


/*
 * This header is at the very beginning of the file
 */

struct bin {
	long	b_magic;	/* magic number, defined below */
	long	b_text;		/* size of text segment in bytes */
	long	b_data;		/* size of data segment in bytes */
	long	b_bss;		/* size of bss segment in bytes */
	long	b_txorg;	/* base address of text segment in memory */
	long	b_dtorg;	/* base address of data segment in memory */
	long	b_bsorg;	/* base address of bss segment in memory */
	long	b_entry;	/* entry point offset in text segment */
	long	b_rsrv[8];	/* reserved for expansion */
};


/*
 * b_text bytes of text segment follow, then b_data bytes
 * of initialized data
 * If the data segment has to be rounded up to a longword boundary,
 * the 1-3 bytes of pad must have been added into the b_text byte count!
 */

#define BMAGIC 0407		/* why not? */
